# Pathtracer for Advanced Computer Graphics

Depdendencies:
- Qt6
  (untested with Qt5, needs CMakeLists.txt adjustments)
- OBJ Loader (included, see `thirdparty` directory)
- Utah Teapot (included, see `newell_teaset`, Source: https://www.cs.utah.edu/~natevm/newell_teaset/newell_teaset.zip)

Features:
- Accelerated Raytracing on triangles using a KD-Tree structure
- Raytracing with *planes*, *spheres* and *triangles*
- Pathtracing with multiple (random) paths in a hemisphere on first object intersection
- PBR Material rendering with a rendering equation using a simple *Blinn-Phong* BRDF 
- A ton of work


## Compiling

```shell
cmake -B build
```

## Running

```shell
build/PathtryCpp
```

*Note: Teapot must be provided in working directory under **newell_teaset/teapot.obj**.*
