#ifndef RAYTRYCPP_RENDERMATERIAL_H
#define RAYTRYCPP_RENDERMATERIAL_H

#include "Ray.h"
#include <QColor>
#include <QVector3D>

namespace raytry {
    class RenderMaterial {
    public:
        QColor diffuseColor;
        QColor specularColor;
        float specularFalloff;

        RenderMaterial(QColor materialColor);
        RenderMaterial(const QColor &diffuseColor, const QColor &specularColor, float specularFalloff);

        ~RenderMaterial() = default;

        [[nodiscard]] QColor brdf(const QVector3D &toLight, const QVector3D &normal, const QVector3D &incomingDir, const QVector3D &outgoingDir) const;
    };

    QColor mixColor(QColor input, float intensity);
    QColor mixColors(QColor color1, const QColor& color2);
    QColor addColors(QColor color1, const QColor& color2);
}// namespace raytry


#endif//RAYTRYCPP_RENDERMATERIAL_H
