#include "Scene.h"
#include "viewerwindow.h"
#include <QApplication>
#include <QtConcurrent/QtConcurrent>

int main(int argc, char **argv) {
    QApplication app(argc, argv);

    raytry::ViewerWindow window;
    window.show();

    const auto updateImage = [&](){ QMetaObject::invokeMethod(&window, "updateImageLabel", Qt::QueuedConnection); };
    raytry::Scene scene{};
#ifdef PROFILING
    scene.render(window, updateImage);
    updateImage();
#else
    QtConcurrent::run(&raytry::Scene::render, &scene, std::reference_wrapper<raytry::ViewerWindow>(window), updateImage)
            .then(updateImage)
            .onFailed([]() {
                qFatal("Rendering scene failed!");
            });
#endif

    return QApplication::exec();
}
