#include "viewerwindow.h"
#include "ui_ViewerWindow.h"

namespace raytry {
    ViewerWindow::ViewerWindow(QWidget *parent) : QMainWindow(parent), ui(new Ui::ViewerWindow), imageLabel{} {
        ui->setupUi(this);
        displayImage = QImage(QSize(window()->width(), window()->height()), QImage::Format::Format_RGBA8888);
        displayImage.fill(QColorConstants::Black);
        imageLabel.setBackgroundRole(QPalette::Base);
        imageLabel.setScaledContents(true);
        updateImageLabel();
        setCentralWidget(&imageLabel);
    }

    ViewerWindow::~ViewerWindow() {
        delete ui;
    }

    QImage &ViewerWindow::getDisplayImage() {
        return displayImage;
    }

    void ViewerWindow::updateImageLabel() {
        imageLabel.setPixmap(QPixmap::fromImage(displayImage));
    }
}// namespace raytry
